(* $Id: sutil.ml,v 1.1 2010-07-23 15:00:31 deraugla Exp $ *)

value rec gcd x y =
  if x < y then
    if x = 0 then y
    else gcd (y mod x) x
  else if x > y then
    gcd y x
  else x
;

value lcm x y = x / gcd x y * y;

value rec lcm_of_list =
  fun
  [ [] -> 1
  | [x] -> x
  | [x :: xl] -> lcm x (lcm_of_list xl) ]
;

value rec mul_div a b c =
  if a >= max_int / b then
    if a < c then
      let g = gcd a c in
      if g > 1 then mul_div (a / g) b (c / g)
      else truncate (float a *. float b /. float c)
    else
      (a / c) * b + mul_div (a mod c) b c
  else
    a * b / c
;

value rho =
  loop [] where rec loop list n =
    if n <= 0 then list else loop [(n - 1) :: list] (n - 1)
;
